// Copyright 2004-2010 Alco Blom
// All rights reserved

// 1.1 adds delivery reports
// 1.1 adds all preferences
// 1.1b4 - fixed Unicode calculate length bug
// 1.1b4 - added value = 710 - circumflex
// 1.1b5 - plug-in Greek symbols modified

// 1.1.1 - added carriage return before signature
// 1.1.1 - fixed SMS length calculation
// 1.1.1 - use defaultNameOrdering from AB
// 1.1.1 - fixed paste bug
// 1.1.1 - adding tooltips 
// 1.1.1 - multiple mobile numbers per person

// 1.1.2 - fixed typo in French resource file
// 1.1.2 - changed doneMouseUp, added countrychanged
// 1.1.2 - updated for 10.4.3, escape URL bug fixed
// 1.1.2 - changed resource path for black_i
// 1.1.2 - added French tooltips

// 1.5   - added Reply to Email
// 1.6   - added eMobile preference pane
// 1.6   - Universal version
// 1.6.1 - fix '\r' '\n' bug in plug-in
// 1.7   - pList
// 2.0   - groups
// 2.1   - reports, fix hasAccount bug, use <textarea>
// 2.2   - added SMS Balance
// 2.2.1 - WebKit 3.0 fix, trunc recipient name
// 2.2.1 - added pref.js, contact bug fix
// 2.2.1 - CloseBoxInset values update
// 2.2.2 - Google Campaign Added
// 2.2.2 - Trial SMS Account Support
// 2.2.3 - more checks on account ID and PIN
// 2.2.3 - fixes for 10.4.11
// 2.2.4 - trial SMS translations complete
// 2.2.4 - A capital ring bug fix
// 2.2.5 - SMS balance comment
// 2.2.6 - corrections Trial SMS Account
// 2.3   - improvement Group SMS key InvalidDestinations
// 2.3   - sorting is now done in the widget plug-in

// 2.4   - support 011 as international prefix
// 2.4   - reject Long SMS and Unicode SMS to USA
// 2.4   - reject Reply to Email and Alphanumeric Sender ID to USA
// 2.4.1 - fixed problems with Mac OX 10.4 (console.log and inArray).
// 2.4.1 - set caller ID to empty for USA in case of Alphanumeric identifier

// 2.5   - new Dock icon
//       - query SMS balance
//       - support iPhone mobile label of AB
//       - change error message 2-way channel

// to do : int. group tel numbers

// to do : caller ID checks
// to do : sync preferences
// to do : problem when Unicode chars in signature

var productVersion = "2.5";
var productComputerVersion = "0250";

var userColor = 'red';
var downloadURL = "";
var old_pin_code = "";

var editable = false;
var backside = false;

var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, element:null, celement:null, melement:null, timer:null};

var recipientName = "";
var defaultRecipientIndex = -1;

var textSMS = "";
var statusError = false;

var hasAccount = false;
var smsbalance = null;

var signatureLen = 0;

var xpos = 0;
var step = 0;
var checkIndex = 0;
var drawInterval = null;
var checkInterval = null;
var addedKeychain = false;

var buySMS = false;
var expired = false;
var updateWidget = false;
var trialAccount = false;

var productURL = "";
var purchaseURL = "";

var queryURL = "";
var errorMessage = "";

var groupSMS = false;
var email2SMS = false;
var membersTotal = 0;

function setName(txt)
{
	document.getElementById("head").innerText = txt;
}

function setStatusText(txt)
{
	statusError = true;
	textSMS = document.getElementById("editdiv").value;

	document.getElementById("editdiv").value = txt;
	document.getElementById("editdiv").readOnly = true;
	return;
}

function setStatusText2(txt)
{
	document.getElementById("editdiv").value = txt;
	document.getElementById("editdiv").readOnly = true;
}

function cleartext()
{
	cleartext(null);
}

function cleartext(event)
{
	buySMS = false;
	expired = false;
	updateWidget = false;
	trialAccount = false;
	
	if (statusError) {
		statusError = false;
		document.getElementById("editdiv").value = textSMS;
		document.getElementById("editdiv").readOnly = false;
		
		textSMS = "";
	} else {
		document.getElementById("editdiv").value = "";
		document.getElementById("unicode").value = "";
		document.getElementById("editdiv").readOnly = false;
		setTotal(signatureLen);
	}

	// stop animation
	if (drawInterval != null) {
		clearInterval(drawInterval);
		drawInterval = null;
		
		clearwalk();
	}
}

function getReplyValue() 
{
	return document.getElementById("replyprefs").selectedIndex;
}

function setReplyValue(replyIndex) 
{
	document.getElementById("replyprefs").options[replyIndex].selected=true;
}

function switchReplyPane(replyMethod)
{
	switch(replyMethod) {
		case 0:
			changeObjectVisibility("replytomobile","visible");
			changeObjectVisibility("replytoemail","hidden");
			changeObjectVisibility("noreply","hidden");
			break;
			
		case 1:
			changeObjectVisibility("replytomobile","hidden");
			changeObjectVisibility("replytoemail","visible");
			changeObjectVisibility("noreply","hidden");
			break;
			
		case 2:
			changeObjectVisibility("replytomobile","hidden");
			changeObjectVisibility("replytoemail","hidden");
			changeObjectVisibility("noreply","visible");
			break;
			
	}
}

function isEmail(emailAddress) {
	var flag = false;
  
	if (emailAddress && emailAddress.match(/^(.+)@(.+)\.(.+)$/)) {
    	flag = true;
    }
  
	return flag;
}

/*
function gatechanged(select)
{	
	var index = select.selectedIndex;
	var gateway = select.options[index].value;
	
	// get mobile number
	var mobile = document.getElementById("to2").value;
	
	// strip all formatting
	mobile = mobile.replace(/[^0-9+]/g, "");
	
	// strip country code "+1"	
	if (mobile.charAt(0) == '+' && mobile.charAt(1) == '1')
		mobile = mobile.substring(2);

	// strip '+' for other countries
	if (mobile.charAt(0) == '+')
		mobile = mobile.substring(1);
		
	// exception for AT&T Wireless
	if (gateway == "@mmode.com") {
		mobile = "1" + mobile;
	}
	
	// set input field to eMobile address
	if (index != 0)
		document.getElementById("emobi").value = mobile + gateway;
	else
		document.getElementById("emobi").value = "";
}
*/
/*
function contactchanged(select)
{	
	var index = select.selectedIndex;
	
	if (index == 0) {
		document.getElementById("to2").value = "";
		document.getElementById("emobi").value = "";
	} else {
		// get mobile number
		var dataValue = select.options[index].value;
		var combo = dataValue.split('\r');
		if (combo.length > 0) {
			mobile = combo[0];
			mobile = internationalNumber(mobile);
			
			document.getElementById("to2").value = mobile;
			
			// update the eMobile address field
			var gates = document.getElementById("gates");
			gates.selectedIndex = 0;
			
			document.getElementById("emobi").value = "";
		}
	}
}
*/

function recipientchanged(recipients)
{	
	var name ="";
	var phonenumber = "";
	var selectedIndex = recipients.selectedIndex;
	
	if (selectedIndex == 0) {
		document.getElementById("to").value = "+";
		name = getLocalizedString('Unknown');
	} else {
		// get mobile number and uniqe id
		var dataValue = recipients.options[selectedIndex].value;
		var combo = dataValue.split('\r');
		if (combo.length > 0)
			phonenumber = combo[0];
					
		// make it international
		if (!isEmail(phonenumber))
			phonenumber = internationalNumber(phonenumber);	
			
		document.getElementById("to").value = phonenumber;
		name = recipients.options[selectedIndex].text;
		
		groupSMS = false;
	}
	
	setName(name);
}

function groupchanged(groups)
{	
	var groupTotal = "n/a";
	
	var selectedIndex = groups.selectedIndex;
	if (selectedIndex != 0) {
		// get uniqe id
		var uid = groups.options[selectedIndex].value;
		
		// get number of mobiles in group
		if (window.widget) {
			membersTotal = ScriptObject.getgrouptotal(uid);
			groupTotal = membersTotal;
		}
		
		groupSMS = true;
	} else
		membersTotal = 0;
	
	// update status text
	var labelText = getLocalizedString('Number of mobiles:');
	document.getElementById('label33').innerText = labelText + groupTotal + ".";
}

function getSelectedGroup()
{	
	var uid = "";
	var groups = document.getElementById('group');
	
	// get selected uniqe id
	var selectedIndex = groups.selectedIndex;
	if (selectedIndex != 0) {
		uid = groups.options[selectedIndex].value;
	}
	
	return uid;
}

function getSelectedGroupName()
{	
	var groupName = "";
	var groups = document.getElementById('group');
	
	// get selected uniqe id
	var selectedIndex = groups.selectedIndex;
	if (selectedIndex != 0) {
		groupName = groups.options[selectedIndex].text;
	}
	
	return groupName;
}

function editclick(event)
{
	if (!editable)
	{
		document.getElementById("editdiv").focus();
		editable = true;
	}
}

function alphaClick(elem)
{	
	var elem2 = document.getElementById("noalphanumericID");
	if (elem2 == elem) {
		document.getElementById("usealphanumericID").checked = 0;
	}
	
	elem2 = document.getElementById("usealphanumericID");
	if (elem2 == elem) {
		document.getElementById("noalphanumericID").checked = 0;
	}
	
}

function setFrontSide()
{
	// default image
	var image = 'images/front.png';
	
	// change color of skin
	var note = document.getElementById('note');

	if (window.widget)
	{
		var key = widget.identifier + "-" + "color";
		var color = widget.preferenceForKey(key);
		if (color == null) {
			color = widget.preferenceForKey("color");
			if (color == null) {
				color = 'red';
			}
		}
		
		switch(color) {
			case 'red':
				image = 'images/red.png';
				break;
				
			case 'green':
				image = 'images/green.png';
				break;
				
			case 'blue':
				image = 'images/blue.png';
				break;
				
			case 'white':
				image = 'images/white.png';
				break;
			
			case 'orange':
				image = 'images/orange.png';
				break;
			
			default:
				image = 'images/front.png';
				break;
				
		}
		
		note.src = image;
		
	} else {
		note.src = image;
	}
}

function loadWidget() 
{
	//setFrontSide();
	setupPreferences();
	adload();
}

function adload() 
{
	var users = "";
	var groups = "";
	
	if (window.widget) {

		// get signature preference
		var signature = getSignature();		
		if (signature != null) {
			signatureLen = getSignatureLen(signature);
		} else {
			signatureLen = 0;
		}
		
		setTotal(signatureLen);
		
		// get mobile numbers from Address Book
		users = ScriptObject.getusers();

		// get groups from Address Book
		groups = ScriptObject.getgroups();
	
		// build the popup menu
		buildusers(users);
		
		buildgroups(groups);
	} else {
	
		// code for Safari
		signatureLen = 0;
		setTotal(signatureLen);
		setName(getLocalizedString('Click Me'));
	}
}

function buildgroups(groups) 
{
	var uid = "";
	var savedIndex = 0;
	var groupFound = false;
	
	if (groups.length == 0) {
		return;
	}
	
	var list = groups.split('\n');
	list.length -= 1;
	
	// the Address Book is empty
	if (list.length <= 0) {
		return;
	}

	// sort by first characters
	// list.sort();
	
	// read preferred group of this instance
	key = widget.identifier + "-" + "group";
	uid = widget.preferenceForKey(key);

	// get groups
	var groups = document.getElementById("group");
	groups.options.length = 0;

	// first item in the group popup menu is:
	groups.options[0] = new Option(getLocalizedString('No group'), "", false, false);

	// add items from the Address Book	
	var j = 0;
	for (var i = 0;i<list.length;i++) {
		
		pair = list[i].split('\t');
		if (pair == "" || pair.length != 2)
			continue;
		
		// get name
		var name = pair[0];
		if (name == null || name == "") {
			alert("zero name");
			continue;
		}
		
		// get uid 
		var uniqueID = pair[1];
		if (uniqueID == null || uniqueID == "") {
			alert("no uniqueID for group duo");
			continue;
		}
		
		// add to group list
		groups.options[i+1] = new Option(name, uniqueID, false, false);

		if (uid != null && uniqueID == uid) {
			savedIndex = i+1;
			groupFound = true;
		}
	}

	// select the preferred group
	if (groupFound) {
		groups.selectedIndex = savedIndex;
		
		// show the number of mobiles in group
		groupchanged(groups);
		groupSMS = false; // was set by groupchanged()
		
		// read preferred group of this instance
		key = widget.identifier + "-" + "mode";
		var smsMode = widget.preferenceForKey(key);
		
		// set mobile to group destination
		if (smsMode != null && smsMode == 1) {
			groupSMS = true;
			
			// get name of group
			var groupName = groups.options[savedIndex].text;

			// get uniqe id
			var uid = groups.options[savedIndex].value;

			// get number of mobiles in group
			if (window.widget && uid != "") {
				membersTotal = ScriptObject.getgrouptotal(uid);
			}

			var header = groupName + " (" + membersTotal + ")";
			setName(header);
			
			// set the tooltip
			var toolString = getLocalizedString('To:');
			toolString =  toolString + "\"" + groupName + "\"";
			
			var phoneNumbers = getPhoneNumbersList();
			if (phoneNumbers != -1 && phoneNumbers != "")
				toolString = toolString + ": " + phoneNumbers;
				
			setHeaderTooltip(toolString);
		}
	}
}

function buildusers(users) 
{
	if (users.length == 0) {
		setName(getLocalizedString('Click Me'));
		return;
	}

	var list = users.split('\n');
	list.length -= 1;
	
	// the Address Book is empty
	if (list.length <= 0) {
		return;
	}
	
	// sort by first characters
	// list.sort();
	
	// get mobile number of instance
	var key = widget.identifier + "-" + "mobile";
	var mobile = widget.preferenceForKey(key);
		
	// split mobile from record ID
	if (mobile != null && mobile != "") {
		var returnIndex = mobile.indexOf('\r');
		if (returnIndex > 0) {
			mobile = mobile.slice(0, returnIndex);
		}
	}
	
	var popup = document.getElementById("popup");
	popup.options.length = 0;
	
	//var popup2 = document.getElementById("popup2");
	//popup2.options.length = 0;

	// first item in the popup menu is:
	var menuitemname = getLocalizedString('Enter');
	popup.options[0] = new Option(menuitemname, "+", false, false);
	//popup2.options[0] = new Option(menuitemname, "", false, false);
	
	// initialize
	var name;
	var number;
	var savedName = "";
	var savedIndex = 0;
	var numberNotFound = true;
	
	// add items from the Address Book	
	var j = 0;
	for(var i = 0;i<list.length;i++) {
		
		pair = list[i].split('\t');
		
		// get name
		name = pair[0];
		if (name == null || name == "") {
			alert("zero name");
			continue;
		}
		
		// get mobile number/uid pair 
		var duo = pair[1];
		if (duo == null || duo == "") {
			alert(name);
			alert("zero duo");
			continue;
		}
		
		// get mobile number and unique ID		
		var combo = pair[1].split('\r');
		if (combo == null || combo.length < 2) {
			alert(name);
			alert("zero combo");
			continue;
		}
		
		// mobile number
		number = combo[0];
		
		// add eMobile label
		if (isEmail(number)) {
			name = name + " (eMobile)";
		}

		// add to main list
		popup.options[i+1] = new Option(name, pair[1], false, false);
		
		// add to second list
		//if (!isEmail(number)) {
			//popup2.options[j+1] = new Option(name, pair[1], false, false);
			//j = j + 1;
		//}
		
		if (mobile != null && mobile == number) {
			savedName = name;
			savedIndex = i+1;
			numberNotFound = false;
		}
	}
	
	if (numberNotFound)
		setName(getLocalizedString('Click Me'));
	else {
		// get first part
		//var firstName = savedName.split(' ');
		//if (firstName.length > 0) {
			//savedName = firstName[0];
		//}
		
		// show first part
		setName(savedName);

		// select the popup menu
		popup.selectedIndex = savedIndex;
		
		// fill in default mobile number
		if (mobile != null) {
		
			if (!isEmail(mobile))
				mobile = internationalNumber(mobile);
				
			document.getElementById("to").value = mobile;
			
			setHeadTooltip(savedName, mobile);
		}
	}
}
/*
function setPopup2()
{
	var popup2 = document.getElementById("popup2");
	popup2.selectedIndex = 0;
	
	var recipients = document.getElementById("popup");
	var selectedIndex = recipients.selectedIndex;
	if (selectedIndex == 0) {
		return;
	} 
	
	// get the mobile number of the selected recipient
	var dataValue = recipients.options[selectedIndex].value;
	
	for(var i = 0;i<popup2.options.length;i++) {
		if (popup2.options[i].value == dataValue) {
			popup2.selectedIndex = i;
			contactchanged(popup2);
			break;
		}
	}
}
*/
function handleXMLResponse(xml)
{
    var days = "?";
    var balance = "?";
    var message = "";
    var keyName = "";
    var dataValue = "";
    var recipients = "0";
    var errorNumber = "0";
    var success = false;
    var softwareUpdate = false;
    var softwareVersion = "";
    var invalidMobileNumbers = "";
    
    var didNotHaveAccount = hasAccount;
    
    var keys = xml.getElementsByTagName("key");
	if (keys.length <= 0) {
		alert("No valid response from query");
		doErrorMessage('1000');
		return;
	} else {
		// initialize global variables 
		errorMessage = "";
		productURL = "";
		purchaseURL = getLocalizedString('Buy SMS Mac');
		trialAccount = false;
	}
	
	// find all keys	
	for (i=0;i<keys.length;i++) {
		keyName = keys[i].firstChild.nodeValue;
		dataValue = keys[i].nextSibling.nextSibling.firstChild.data;
		
		//alert(keyName);
		//alert(dataValue);
		
		switch(keyName) {
			case "Error":
				success = false;
				errorNumber = dataValue;
				break;
				
			case "ErrorMessage":
				errorMessage = dataValue;
				break;
				
			case "ID":
				success = true;
				break;
				
			case "Balance":
				balance = dataValue;
				smsbalance = balance;
				break;
				
			case "Recipients":
				recipients = dataValue;
				break;
				
			case "Expiration":
				days = dataValue;
				break;
				
			case "ProductVersion":
				softwareVersion = dataValue;
				softwareUpdate = true;
				break;
				
			case "ProductURL":
				productURL = dataValue; // global variable
				break;
				
			case "PurchaseURL":
				purchaseURL = dataValue; // global variable
				purchaseURL = purchaseURL + getLocalizedString('Locale');
				break;
				
			case "InvalidDestinations":
				var invalidDestinationsElem = keys[i];
				invalidDestinationsElem = invalidDestinationsElem.nextSibling.nextSibling; // the array element
				var numbers = invalidDestinationsElem.getElementsByTagName("string"); // returns a nodeList of any elements that have a given tag
				nInvalidDestinations = numbers.length;
				
				// build a string of invalid mobile numbers
				if (nInvalidDestinations > 0) {
					
					for (var k = 0; k < nInvalidDestinations; k++) {
						invalidMobileNumber = numbers[k].firstChild.nodeValue;
						if (k > 0)
							invalidMobileNumbers = invalidMobileNumbers + ", ";
						invalidMobileNumbers = invalidMobileNumbers + invalidMobileNumber;
					}
					
					// echo these numbers to the console
					alert('The SMS was not sent to the following mobile numbers below, because they are not accepted:');
					alert(invalidMobileNumbers);
				}
				
				break;
				
			case "Trial":
				trialAccount = true; // global variable
				break;

			default:
				break;
				
		} // of switch
	} // of for loop
	
	
	// an error occurred
	if (!success) {
		doErrorMessage(errorNumber);
		return;
	} else {
		alert('Success');
	}
	
	// expiration is near
	if (days != "?" && days <= 21 && trialAccount == false) {
	
		expired = true;
		
		// insert the number of days left
		if (days == 0) {
			message = getLocalizedString('ExpireToday');
		} else {
			message = getLocalizedString('Expire');
			message = message.replace(/%d/i, days);
		}
		
		hasAccount = true;
		
	} else if (email2SMS) {
	
		message = getLocalizedString('SuccessEmobile');
	
	// show balance
	} else if (balance != "?") {
			
		// insert the number of SMS left
		if (recipients != "0" && recipients != "1") {
		
			message = getLocalizedString('SuccessN');
			message = message.replace(/%n/i, recipients);
			message = message.replace(/%d/i, balance);

		} else {
		
			message = getLocalizedString('Success');
			message = message.replace(/%d/i, balance);
			
		}
		
		// store SMS balance
		var number = Number(balance);
		
		if (groupSMS && invalidMobileNumbers != "") { // show invalid destination mobile numbers
		
			message = message + getLocalizedString('InvalidDestinations');
			message = message + invalidMobileNumbers + ".";
		
	
		} else if (number < 10) { // reminder to buy more SMS
		
			buySMS = true;
			
			// buy more SMS
			message = message + " " + getLocalizedString('BuyMore');
			
			// trial SMS
			if (trialAccount) { // reminder of trial account
			
				if (number == 0) {
					message = getLocalizedString('TrialEnd');
				} else {
					message = getLocalizedString('TrialPeriod');
					message = message.replace(/%d/i, balance);
				}
				
				buySMS = false;
			}

		} else if (softwareUpdate) { // reminder of software update
		
			updateWidget = true;
			
			// software update
			var remark = getLocalizedString('NewVersion');
			remark = remark.replace(/%s/i, softwareVersion);
			message = message + " " + remark;
			
		}
		
		hasAccount = true;
	} else {
		message = "Incomplete XML response";
	}
	
	// not in this case
	if (trialAccount) {
		hasAccount = false;
	}

	// update strings between Buy SMS Mac and Buy SMS
	if (hasAccount && didNotHaveAccount == false) {
		updateHasAccountStatus(true);
	}
	
	// update strings between Buy SMS Mac and Buy SMS
	if (trialAccount) {
		updateHasAccountStatus(false);
	}

	// show the SMS balance c.q. message about buy more SMS or software update
	setStatusText2(message);
	
	// update SMS Balance in preference pane
	if (smsbalance != null) {
		setBalance(smsbalance);
	}
}

function handleResponse(txt)
{
	var line = "";
		
	if (txt.length == 0) {
		alert("No valid response from query");
		doErrorMessage('1000');
		return;
	} else {
		line = txt;
	}
	
	var lines = txt.split('\n');
	if (lines.length > 0) {
		line = lines[0];
	
		// NSRange range = [line1 rangeOfString:@"Software error"];
		
		txt = line.split(' ');
		
		if (txt.length > 1) {
			
			if (txt[0] == "ERR:") {
				if (txt[1] != null)
					doErrorMessage(txt[1]);
				else
					setStatusText2(line);
			} else if (txt[0] == "ID:") {
				var message;
				var n = "?";
				var days = "?";
				
				// get the second line
				if (lines.length > 1) {
					line = lines[1];
					txt = line.split(' ');
										
					// should contain number of SMS left
					if (txt.length > 1 && txt[0] == "BAL:") {
						n = txt[1];
					}
				}
								
				// get the third line
				if (lines.length > 2) {
					line = lines[2];
					txt = line.split(' ');
										
					// should contain number of days left
					if (txt.length > 1 && txt[0] == "EXP:") {
						days = txt[1];
					}
				}

				// show feedback
				if (days != "?" && days <= 21) {
				
					expired = true;
					
					// insert the number of days left
					message = getLocalizedString('Expire');
					message = message.replace(/%d/i, days);
				} else if (email2SMS) {
				
					message = getLocalizedString('SuccessEmobile');

				} else if (n != '?') {
					// insert the number of SMS left
					message = getLocalizedString('Success');
					message = message.replace(/%d/i, n);
				
					// buy more SMS
					if (n != "?") {
						var number = Number(n);
						if (number < 10) {
							message = message + " " + getLocalizedString('BuyMore');
							
							buySMS = true;
						}
					}
				}
				
				// show the SMS balance
				setStatusText2(message);
				
				// remember the fact
				hasAccount = true;
			} else {
				setStatusText2(getLocalizedString('kErrUnknown'));
			}
			
		} else {
			// display this line
			setStatusText2(line);
		}
		
	} else {
		// display this line
		setStatusText2(line);
	} 
	
	return;
}

function processReqChange() {

    // only if req shows "loaded"
    if (req.readyState == 4) {

		// stop animation
		if (drawInterval != null) {
			clearInterval(drawInterval);
			drawInterval = null;
		}

		clearwalk();

		// only if "OK"
        if (req.status == 200) {
            alert(req.responseText);
            handleResponse(req.responseText);
         } else {
         	alert("req.status = " + req.status + " != 200");
            doErrorMessage('1000');
         }
    }
}

function processReqChangeXML() {

    // only if req shows "loaded"
    if (req.readyState == 4) {

		// stop animation
		if (drawInterval != null) {
			clearInterval(drawInterval);
			drawInterval = null;
		}

		clearwalk();

		// only if "OK"
        if (req.status == 200) {
            alert(req.responseText);
            handleXMLResponse(req.responseXML); // plist response
         } else {
         	alert("req.status  =  " + req.status + " != 200");
            doErrorMessage('1000');
         }
    }
}

function sendsms()
{
	var usaSMS = false;
	var unicode = false;
	var callerID = null;
	var delivery = false;

	var maxLen = (160 - 7) * 3;
	var maxLenUnicode = (70 - 7) * 3;

	queryURL = "";

	//alert('calling sendsms();');

	// renew SMS Mac subscription
	if (expired) {
		doRenewOpenURL();
		expired = false;

		// back to initial state
		setStatusText2(getLocalizedString('Clear'));

		return;
	}
	
	// trial SMS
	if (trialAccount) {
		doPurchaseOpenURL();
		trialAccount = false;
		
		// back to initial state
		setStatusText2(getLocalizedString('Clear'));
		
		return;
	}
	
	// software update
	if (updateWidget) {
		doSoftwareUpdateURL();
		updateWidget = false;

		// back to initial state
		setStatusText2(getLocalizedString('Clear'));

		return;
	}

	// buy more SMS
	if (buySMS) {
		doBuySMSOpenURL();
		buySMS = false;

		// back to initial state
		setStatusText2(getLocalizedString('Clear'));

		return;
	}
		
	// don't SMS error messages
	if (statusError) {
		setStatusText2(getLocalizedString('Clear'));
		return;
	}

	// do we have something to send?
	var txt = document.getElementById("editdiv").value;
	if (txt.length == 0)
	{
		setStatusText(getLocalizedString('NoText'));
		return;
	}
	
	// account details
	var pin = document.getElementById("pin").value;;
	var email = document.getElementById("mail").value;
	
	// check account details
	pin = document.getElementById("pin").value;
	if (pin == null || pin.length != 4 || pin == '0000')
	{
		alert('PIN error length :' + pin);
		setStatusText(getLocalizedString('AccountError'));
		return;
	}

	// check PIN value
	var aNumber = Number(pin);
	if (isNaN(aNumber))
	{
		alert('PIN is not a number');
		setStatusText(getLocalizedString('AccountError'));
		return;
	}
	
	// check account ID
	email = document.getElementById("mail").value;
	if (email == null || email.length == 0 || !isEmail(email))
	{
		alert('Account ID error: ' + email);
		setStatusText(getLocalizedString('AccountError'));
		return;
	} else
	{
		email = escape(email);
	}
	
	// get more preferences
			
	// get callerID preference
	callerID = getCallerID();		
	if (callerID != null) {
		callerID = pescape(callerID);
	}

	// get delivery preference
	delivery = getDelivery();		

	// get signature preference
	var signature = getSignature();		
	if (signature != null) {
		signatureLen = getSignatureLen(signature);
		
		// add signature
		txt = txt + signature;		
	} else
		signatureLen = 0;
		
	var mobile = "";
	var phonenumber = "";
	var phonenumbers = "";
	
	if (groupSMS) {
	
		// group SMS
		
		// mobile = "Group name";
		mobile = getSelectedGroupName();
		
		// get list of mobile numbers
		if (window.widget) {
			var uid = getSelectedGroup();
			
			if (uid.length == 0) {
				setStatusText('No group is selected');
				return;
			}
			
			phonenumber = getPhoneNumbersList();
			if (phonenumber == "") {
				setStatusText(getLocalizedString('NoRecipient'));
				return;
			}
			if (phonenumber == -1) {
				setStatusText(getLocalizedString('NoPlus'));
				return;
			}
		}
		
	} else {
	
		// single SMS
		
		phonenumber = document.getElementById("to").value;
		if (phonenumber.length < 5)
		{
			setStatusText(getLocalizedString('NoRecipient'));
			return;
		}
		
		// used in feedback text
		mobile = phonenumber;
		
		// check configuration for email2SMS
		if (isEmail(phonenumber)) {	
		
			email2SMS = true;
			
			var emailAddress = document.getElementById("replyemailaddress").value;
			if (emailAddress == null || emailAddress == "") {
				setStatusText(getLocalizedString('NoReplyEmailAddress'));
				return;
			}
			
		} else {
			
			var msisdn;
			
			email2SMS = false;
			
			// check format of international mobile number
			if (phonenumber.charAt(0) == '+') {
			
				if (phonenumber.charAt(1) == '1') {
					usaSMS = true;
					msisdn = phonenumber.substring(1);
				}
				
			} else if (phonenumber.charAt(0) == '0' && phonenumber.charAt(1) == '0') {
			
				if (phonenumber.charAt(2) == '1') {
					usaSMS = true;
					msisdn = phonenumber.substring(2);
				}
				
			} else if (phonenumber.charAt(0) == '0' && phonenumber.charAt(1) == '1' && phonenumber.charAt(2) == '1') {
			
				if (phonenumber.charAt(3) == '1') {
					usaSMS = true;
					msisdn = phonenumber.substring(3);
				}
				
			} else {
				alert("The mobile number is not in international format : " + phonenumber);
				setStatusText(getLocalizedString('NoPlus'));
				return;
			}
			
			// correct usaSMS for Canadian and Caribbean area codes
			if (usaSMS) {
				var areaCode = msisdn.substring(1, 4);
								
				var canadaCodes  =  new Array(403,780,250,604,778,204, 506,709,902,289,905,416,647,519,613,705,807,418,450,514,819,306,867);
				var caribbeanCodes  =  new Array(684,671,441,264,268,297,242,246,284,345,767,809,829, 473,876,664,869,758,784,868,649,340);

				// check on !Array.prototype.indexOf
				
				if (findInArray(canadaCodes, parseInt(areaCode))) {
					usaSMS = false;
				} else if (findInArray(caribbeanCodes, parseInt(areaCode))) {
					usaSMS = false;
				}
			}
			
			// reject Alphanumeric Sender ID for the USA
			if (usaSMS) {
				var replyIndex = getReplyValue();
				if (replyIndex == 2) { // No Reply, Alphanumeric Sender ID
					if (document.getElementById("usealphanumericID").checked) {
						callerID = "";
					}
				}
			}
		}
	}
	
	// escape phonenumber(s)
	phonenumber = pescape(phonenumber);
	
	if (window.widget) {
		if (ScriptObject.isUnicode(txt)) {
			unicode = true;
			maxLen = maxLenUnicode; // 3 SMS allowed when Unicode
			alert("Unicode SMS ");
		}
	}

	// calculate the length of the SMS
	if (unicode)
		len = txt.length;
	else
		len = gsmLength(txt);
		
	// update total just in case
	setTotal(len);
	
	// check on SMS length
	if (len > maxLen) {
		// the SMS exceeds 160 or (70-7)*2 characters
		var message = getLocalizedString('TooMany');
		message = message.replace(/%d/i, maxLen);
		setStatusText(message);
		return;
	}
	
	// the USA does not support Long SMS and Unicode SMS
	if (usaSMS) {
		if (unicode) {
			var message = getLocalizedString('kErrUnicodeNotSupported');
			setStatusText(message);
			return;
		}
		if (len > 160) {
			var message = getLocalizedString('kErrLongSMSNotSupported');
			setStatusText(message);
			return;
		}
	}
	
	// cut to the maximum length
	txt = txt.substring(0, maxLen);

	// escape special characters
	var sms = "";
	if (window.widget) {	
		sms = ScriptObject.escape(txt);	
	}
			
	// initial query
	var url = "http://backend.smsmac.com/sendsms.php?prod=WGT";
	url = url + productComputerVersion;

	// build query
	url = url + "&email=" + email + "&pin=" + pin + "&destination=" + phonenumber + "&text=" + sms;
	
	if (email2SMS) {
	
		var emailAddress = document.getElementById("replyemailaddress").value;
		url = url + "&from=" + escape(emailAddress);
		
	} else {
		// add callerID
		if (callerID != null && callerID != "")
			url = url + "&from=" + callerID;
			
		// reply by email
		var replyIndex = getReplyValue();
		if (replyIndex == 1) {
			url = url + "&reply=email";
			
			if (callerID == null || callerID == "") {
				setStatusText(getLocalizedString('NoReplyEmailAddress'));
				return;
			}
		}
		
		// add delivery parameter
		if (delivery)
			url = url + "&deliv_ack=1";
				
		// add copy SMS parameter
		if (getCopySMS())
			url = url + "&cc=1";
			
		// add report email address
		if (delivery || getCopySMS()) {
			var reportEmailAddress = document.getElementById("report").value;
			
			// use account ID when not defined
			if (reportEmailAddress == null || reportEmailAddress.length == 0 || !isEmail(reportEmailAddress))
				reportEmailAddress = email;
			else
				reportEmailAddress = escape(reportEmailAddress);
				
			// add report email address parameter
			url = url + "&contact=" + reportEmailAddress;
		}
	}
	
	// support concat
	var concat = calculateNumberOfSMS(unicode, len);
	if (concat > 1)
		url = url + "&concat=" + concat;

	// support Unicode
	if (unicode)
		url = url + "&unicode=1";
	
	// remember for fallback
	queryURL = url;
	
	// log query to console
	var hidePIN = url;
	hidePIN = hidePIN.replace(/pin=\d\d\d\d/, "pin=xxxx");
	alert(hidePIN);
	
	setStatusText(getLocalizedString('Sending') + ' (' + mobile + ')');
	
	// start animation
	if (drawInterval == null) {
		xpos = 0;
		step = 0;
		drawInterval = setInterval("walk();", 200);
	}
	
    if (window.XMLHttpRequest) {
        req = new XMLHttpRequest();
        req.onreadystatechange = processReqChangeXML;
        req.open("GET", url, true); // url, true
        req.overrideMimeType('text/xml'); // added to handle XML
        req.send(null);
	} else {
		alert(url);
	}
}

function mousemove (event)
{
	if (!flipShown)
	{
		// fade in the flip widget
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; // set it back one frame
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.element = document.getElementById ('flip');
		animation.celement = document.getElementById ('eraser');
		animation.melement = document.getElementById ('icon');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 1.0;
		animate();
		flipShown = true;
	}

	if (!editable)
	{
		document.getElementById("editdiv").focus();
		editable = true;
	}
}

function mouseexit (event)
{
	if (flipShown)
	{
		// fade in the flip widget
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; // set it back one frame
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.element = document.getElementById ('flip');
		animation.celement = document.getElementById ('eraser');
		animation.melement = document.getElementById ('icon');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}

	if (editable)
	{
		document.getElementById("editdiv").blur();
		editable = false;
	}
}

function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.element.style.opacity = animation.now;
	animation.celement.style.opacity = animation.now;
	animation.melement.style.opacity = animation.now;
}

// preferences

function showbackside(event)
{
	old_pin_code = document.getElementById("pin").value;
	
	var front = document.getElementById("front");
	var back = document.getElementById("behind");
	
	if (window.widget)
		widget.prepareForTransition("ToBack");
	
	front.style.display="none";
	back.style.display="block";
	
	if (window.widget)		
		setTimeout ('widget.performTransition();', 0);	

	document.getElementById('fliprollie').style.display = 'none';
	
	// select the preferred preference pane
	var prefs = document.getElementById("preferences");
	if (groupSMS)
		prefs.selectedIndex = 2;
	else
		prefs.selectedIndex = 1;
	
	prefchanged(prefs);
	
	// done
	backside = true;
}

function doneMouseUp()
{
	var phonenumber;
	
	var prefs = document.getElementById("preferences");
	var selectedPref = prefs.selectedIndex;
	
	//var phonenumber = document.getElementById("emobi").value;
	
	// preference panes
	/*
	if (selectedPref == 9 && phonenumber != "") { // we are in the emobile preference pane
		
		groupSMS = false;
		
		var recipients = document.getElementById("popup2");
		var selectedIndex = recipients.selectedIndex;
		
		if (selectedIndex == 0) {
			name = getLocalizedString('Unknown');
		} else {
			name = recipients.options[selectedIndex].text;
		}
		
		// get first name
		//var firstName = name.split(' ');
		//if (firstName.length > 0) {
			//name = firstName[0];
		//}

		document.getElementById("to").value = phonenumber;
		
		setName(name);
		setHeadTooltip(name, phonenumber);
		
		// todo : set the recipients popup menu selected index
		
	} else 
	*/
	if (selectedPref == 1) { // we are in the recipients preference pane
	
		groupSMS = false;
		
		// get the mobile number from the input field
		phonenumber = document.getElementById("to").value;
	
		var recipients = document.getElementById("popup");
		var selectedIndex = recipients.selectedIndex;
		
		if (selectedIndex == 0) {
			if (phonenumber == null || phonenumber.length <= 1)
				phonenumber = getLocalizedString('Click Me');
			else
				recipients.options[0].value = phonenumber;
				
			setName(phonenumber);
			
			// set the tooltip
			var toolString = getLocalizedString('To:');
			toolString =  toolString + phonenumber;
			setHeaderTooltip(toolString);
			
		} else {
			var recipientName = recipients.options[selectedIndex].text;
			
			// get first name
			//var firstName = recipientName.split(' ');
			//if (firstName.length > 0) {
				//recipientName = firstName[0];
			//}

			// set name of mobile
			setName(recipientName);
			
			// set the tooltip
			setHeadTooltip(recipientName, phonenumber);
		}
		
	} else if (selectedPref == 2) { // we are in the groups preference pane
	
		groupSMS = true;
		
		// get the selected group index
		var groups = document.getElementById("group");
		var selectedIndex = groups.selectedIndex;
		
		if (selectedIndex == 0) {
			setName(getLocalizedString('Click Me'));
			
			// set the tooltip
			setHeaderTooltip("");
		} else {
			// get name of group
			var groupName = groups.options[selectedIndex].text;
			groupName = groupName + " (" + membersTotal + ")";
			
			// set header of mobile
			setName(groupName);
						
			// set the tooltip
			var toolString = getLocalizedString('To:');
			toolString =  toolString + "\"" + groupName + "\"";
			
			var phoneNumbers = getPhoneNumbersList();
			if (phoneNumbers != -1 && phoneNumbers != "")
				toolString = toolString + ": " + phoneNumbers;
				
			setHeaderTooltip(toolString);	
		}
		
	} else {
		;// todo
	}
	
	// switch out
	
	// save preferences
	savePreferences();
	saveInstances();
		
	// animate
	var front = document.getElementById("front");
	var back = document.getElementById("behind");
	
	if (window.widget)
		widget.prepareForTransition("ToFront");
	
	front.style.display="block";
	back.style.display="none";
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);
		
	backside = false;

	// update total etc.
	var txt = document.getElementById("editdiv").value;
	setMetrics(txt);
}

function savePreferences()
{	
	var addcaller = 0;
	var replybyemail = 0;

	var pin_code = document.getElementById("pin").value;
	var email_address = document.getElementById("mail").value;

	var caller = document.getElementById("caller").value;
	var replyemailaddress = document.getElementById("replyemailaddress").value;
	var reportemailaddress = document.getElementById("report").value;
	
	var alphanumericID = document.getElementById("alphanumericID").value;
	var usealphanumericID = document.getElementById("usealphanumericID").checked;
	
	var replyValue = getReplyValue();
	switch(replyValue) {
		case 0:
			addcaller = 1;
			break;
			
		case 1:
			replybyemail = 1;
			break;
	}
		
	var delivery = document.getElementById("delivery").checked;
	var copysms = document.getElementById("copysms").checked;

	var signaturetxt = document.getElementById("signaturetxt").value;
	var addsignature = document.getElementById("addsignature").checked;

	var countrycode = document.getElementById("countrycode").value;
	var addcountrycode = document.getElementById("addcountrycode").checked;

	var stripzero = document.getElementById("stripzero").checked;

	if (window.widget)
	{
		widget.setPreferenceForKey(pin_code, createkey("pin"));
		widget.setPreferenceForKey(email_address, createkey("mail"));
		
		widget.setPreferenceForKey(hasAccount, createkey("has"));
		
		if (smsbalance != null) {
			widget.setPreferenceForKey(smsbalance, createkey("balance"));
		}
		
		if (email_address.length > 0) {
			
			var combined = pin_code + "," + email_address;
			
			if (pin_code != old_pin_code) {
			
				ScriptObject.savepin(combined);
				old_pin_code = pin_code;
				
			} else {
				
				// coming from pre-1.5, store PIN if necessary
				if (addedKeychain == false) {
					ScriptObject.storepin(combined);
					addedKeychain = true;
				}
			}
		}

		widget.setPreferenceForKey(caller, createkey("caller"));
		widget.setPreferenceForKey(replyemailaddress, createkey("replyemailaddress"));
		widget.setPreferenceForKey(reportemailaddress, createkey("reportemailaddress"));
		widget.setPreferenceForKey(alphanumericID, createkey("alphanumericID"));
		
		widget.setPreferenceForKey(addcaller, createkey("addcaller"));
		widget.setPreferenceForKey(replybyemail, createkey("replybyemail"));
		widget.setPreferenceForKey(usealphanumericID, createkey("usealphanumericID"));

		widget.setPreferenceForKey(delivery, createkey("delivery"));
		widget.setPreferenceForKey(copysms, createkey("copysms"));
 
		widget.setPreferenceForKey(signaturetxt, createkey("signaturetxt"));
		widget.setPreferenceForKey(addsignature, createkey("addsignature"));
		
		widget.setPreferenceForKey(countrycode, createkey("countrycode"));
		widget.setPreferenceForKey(addcountrycode, createkey("addcountrycode"));

		widget.setPreferenceForKey(stripzero, createkey("stripzero"));
	}

	// calculate new signature length
	var signature = getSignature();
	if (signature != null) {
		signatureLen = getSignatureLen(signature);
	} else {
		signatureLen = 0;
	}	
}

function saveInstances()
{	
	var mobileNumber;
	var groupUID = "";
	var smsMode = 0;
	
	var recipients = document.getElementById("popup");
	var selectedIndex = recipients.selectedIndex;
	
	// get the selected mobile number
	if (selectedIndex == 0) {
		mobileNumber = document.getElementById("to").value;
	} else {
		mobileNumber = recipients.options[selectedIndex].value;
	}

	// get the selected group
	groupUID = getSelectedGroup();
	
	if (groupSMS)
		smsMode = 1;
		
	if (window.widget) {
		var key;
	
		key = widget.identifier + "-" + "mobile";
		widget.setPreferenceForKey(mobileNumber, key);
		
		key = widget.identifier + "-" + "group";
		widget.setPreferenceForKey(groupUID, key);
		
		key = widget.identifier + "-" + "mode";
		widget.setPreferenceForKey(smsMode, key);

		key = widget.identifier + "-" + "color";
		widget.setPreferenceForKey(userColor, key);
		
		widget.setPreferenceForKey(userColor, "color");
	}
}

function removeInstances()
{
	alert("removing instances");
	
	if (window.widget) {
		var key;
	
		key = widget.identifier + "-" + "mobile";
		widget.setPreferenceForKey(null, key);

		key = widget.identifier + "-" + "group";
		widget.setPreferenceForKey(null, key);

		key = widget.identifier + "-" + "color";
		widget.setPreferenceForKey(null, key);
	}
}

function createkey(key)
{
	return "SMSMac-" + key;
}

function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}

function entericon(event)
{
	var icon = document.getElementById('icon');
	if (icon != null)
		icon.style.backgroundImage = "url(images/letterb.png)";
}

function exiticon(event)
{
	var icon = document.getElementById('icon');
	if (icon != null)
		icon.style.backgroundImage = "url(images/letter.png)";
}

function entereraser(event)
{
	var icon = document.getElementById('eraser');
	if (icon != null)
		icon.style.backgroundImage = "url(images/eraserb.png)";
}

function exiteraser(event)
{
	var icon = document.getElementById('eraser');
	if (icon != null)
		icon.style.backgroundImage = "url(images/eraser.png)";
}

function readSMSMacPrefs() 
{
	var newCallerID = false;
	
	if (window.widget) {
	
		alert("reading the SMS Mac plist");
		
		var things = ScriptObject.readPreferences();
		if (things) {
			var count = things.length;
			
			for (var i = 0;i<count;i+=2) {
				key = things[i];
				value = things[i+1];
				
				if (value == null || value.length == 0) {
					continue;
				}
				
				alert(key);
				alert(value);
				
				var element;
				switch(key) {
					case 'HasAccount':
						element = document.getElementById("has");
						hasAccount = value;
						break;
						
					case 'Balance':
						smsbalance = value;
						setBalance(smsbalance);
						break;
						
					case 'Email':
						element = document.getElementById("mail");
						element.value = value;
						break;
						
					case 'PIN':
						element = document.getElementById("pin");
						element.value = value;
						break;
						
					case 'MobileNumberMe':
						element = document.getElementById("caller");
						element.value = value;
						newCallerID = true;
						break;
					
					case 'CallerID':
						if (newCallerID == false) {
							element = document.getElementById("caller");
							element.value = value;
						}
						break;
						
					case 'ReplyEmailAddress':
						element = document.getElementById("replyemailaddress");
						element.value = value;
						break;
					
					case 'ReportEmailAddress':
						element = document.getElementById("report");
						element.value = value;
						break;
						
					case 'AlphanumericID':
						element = document.getElementById("alphanumericID");
						element.value = value;
						break;
					
					case 'UseCallerID':
						if (value) {
							setReplyValue(0);
						}
						break;
						
					case 'UseReplyByEmail':
						if (value) {
							setReplyValue(1);
						}
						break;
						
					case 'UseAlphanumericID':
						element = document.getElementById("usealphanumericID");
						element.checked = value;
						
						if (value) {
							element = document.getElementById("noalphanumericID");
							element.checked = 0;
						}
						
						break;
						
					case 'Delivery':
						element = document.getElementById("delivery");
						element.checked = value;
						break;
						
					case 'CountryCode':
						element = document.getElementById("countrycode");
						element.value = value;
						break;
						
					case 'AddCountry':
						element = document.getElementById("addcountrycode");
						element.checked = value;
						break;
						
					case 'StripZero':
						element = document.getElementById("stripzero");
						element.checked = value;
						break;
						
					case 'Signature':
						element = document.getElementById("signaturetxt");
						element.value = value;
						break;
						
					case 'AddSignature':
						element = document.getElementById("addsignature");
						element.checked = value;
						break;
						
					case 'EmailCopySMS':
						element = document.getElementById("copysms");
						element.checked = value;
						break;
						
					default:
						break;
				}
			}
			
		} else {
		
			readPIN();
			
		}
		
	} // window.widget
}

function readPIN() 
{
	// read PIN preference
	if (window.widget) {		
		var pin = ScriptObject.getpin();
		if (pin != null) {
			// set UI element
			var element = document.getElementById("pin");
			element.value = pin;
		}
	}
}

function doResendPIN()
{
	if (window.widget) {
		var url = getLocalizedString('PINHelpPage');
		
		if (false) { // hasAccount
			var email = document.getElementById("mail").value;
			if (email != null && email.length != 0) {
				email = escape(email);
				url = url + "&account=" + email;
			}
		}
		
		widget.openURL(url);
	}
}

function goHome()
{
	if (window.widget) {
		var s = getLocalizedString('SMS Mac Home');
		widget.openURL(s);
	}
}

function doOrder()
{
	if (window.widget) {
		var url;
	
		if (hasAccount) {
			url = addCampaign(getLocalizedString('Buy SMS'), 'buysms', true);
		} else {
			url = addCampaign(getLocalizedString('Buy SMS Mac'), 'subscribe', false);
		}
		
		widget.openURL(url); 
	} 
}

function doHelp()
{
	var url;
	var element = document.getElementById("preferences");
	var index = element.selectedIndex;
	
	if (window.widget) {
	
		switch(index) {
			case 0:
				url = getLocalizedString('MainHelpPage');
				break;
				
			case 1:
				url = getLocalizedString('SelectHelpPage');
				break;
				
			case 2:
				url = getLocalizedString('GroupHelpPage');
				break;
				
			case 3:
				url = getLocalizedString('AccountHelpPage');
				break;
	
			case 4:
				url = getLocalizedString('CallerIDHelpPage');
				break;
	
			case 5:
				url = getLocalizedString('CountryHelpPage');
				break;
	
			case 6:
				url = getLocalizedString('SignatureHelpPage');
				break;
	
			case 7:
				url = getLocalizedString('DeliveryHelpPage');
				break;
				
			case 8:
				url = getLocalizedString('SelectHelpPage');
				break;
				
			default:
				url = getLocalizedString('MainHelpPage');
				break;
		}

		// load web page
		widget.openURL(url);
	} 
}

function getLocalizedString(key)
{
	try {
	
		var ret = localizedStrings[key];
		if (ret === undefined) {
			ret = key;
		}
		
		return ret;
			
	} catch (ex) {}

	return key;
}

function selectall()
{
	var element = document.getElementById ("editdiv");
	element.select();
}

function doCut(elem) {
	;
}

function doPaste(elem) {
	;
}

function myFunc() {
	var elem = document.getElementById ("editdiv");
	doChars(elem);
}

function keydown(event)
{
	if (event.metaKey && String.fromCharCode(event.charCode) == 'a')
	{
		selectall();
		event.stopPropagation();
		event.preventDefault();
		
	}
	
	// Paste - Cmd-V
	if (event.metaKey && String.fromCharCode(event.charCode) == 'v')
	{
		setTimeout("myFunc()", 100);
	}
	
	// Cut - Cmd-X
	if (event.metaKey && String.fromCharCode(event.charCode) == 'x')
	{
		setTimeout("myFunc()", 100);
	}

}

document.addEventListener("keydown", keydown, true);

function focus ()
{
	if (!editable)
	{
		document.getElementById("editdiv").focus();
		editable = true;
	}
}

function blur ()
{
	if (editable)
	{
		document.getElementById("editdiv").blur();
		editable = false;
	}
}

function onhide ()
{
	blur();
}

function onremove ()
{
	if (window.widget)
	{
		// save preferences
		savePreferences();
		
		// erase the PIN code
		// alert("removing the PIN code from widget's preferences");
		// widget.setPreferenceForKey (null, createkey("pin"));
	}
}

if (window.widget)
{
	widget.onhide = onhide;
	widget.onremove = onremove;
}

// widget is the front-most widget

window.onfocus = focus;
window.onblur = blur;

function doErrorMessage(error)
{
	switch(error) {
		case '105':
			setStatusText2(getLocalizedString('kErrInvalidDestination'));
			break;
		
		case '106':
			setStatusText2(getLocalizedString('kErrInvalidSenderID'));
			break;
		
		case '1000':
			setStatusText2(getLocalizedString('kErrNoInternet'));
			break;
			
		case '1001':
			setStatusText2(getLocalizedString('kErrAuthenticationFailed'));
			break;
			
		case '1002':
			var msg;
			
			if (trialAccount) {
				msg = getLocalizedString('TrialEnd');
			} else {
				msg = getLocalizedString('kErrNoTicksLeft');
			}
			
			setStatusText2(msg);
			break;
			
		case '1003':
			setStatusText2(getLocalizedString('kErrAccountFrozen'));
			break;
			
		case '1004':
			setStatusText2(getLocalizedString('kErrAccountingDB'));
			break;
			
		case '1011':
			setStatusText2(getLocalizedString('kErrConnectDB'));
			break;
			
		case '1018':
			if (trialAccount) {
				setStatusText2(getLocalizedString('TrialExpired'));
			} else {
				expired = true;
				setStatusText2(getLocalizedString('kErrExpired'));
			}
			break;
			
		case '1025':
			setStatusText2(getLocalizedString('kErrGatewayUnreachable'));
			break;
			
		case '1050':
			setStatusText2(getLocalizedString('kErrNumberTiedToOtherAccount'));
			break;
			
		case '1060':
			setStatusText2(getLocalizedString('kErrTooManyRecipients'));
			break;
			
		case '1061':
			setStatusText2(getLocalizedString('kErrTooManyQueries'));
			break;
			
		case '5000':
			setStatusText2(getLocalizedString('kErrSMSScriptCrash'));
			break;
			
		case '6001':
			setStatusText2(getLocalizedString('kErrFeatureNotSupported') + 'Unicode.');
			break;
			
		case '6002':
			setStatusText2(getLocalizedString('kErrFeatureNotSupported') + 'Long SMS.');
			break;
			
		case '6004':
			setStatusText2(getLocalizedString('kErrFeatureNotSupported') + 'Flash.');
			break;
			
		case '6008':
			setStatusText2(getLocalizedString('kErrReplyByEmailNotSupported'));
			break;
			
		case '1097':
			//callFallback();
			break;
			
		default:
			var msg = getLocalizedString('kError') + error;
			if (errorMessage != "")
				msg = msg + ". " + errorMessage;

			setStatusText2(msg);
			break;
	}
}

function callFallback()
{
	var len = queryURL.length;
	var questionMark = queryURL.indexOf('?');
	var fbURL = queryURL.substring(questionMark, len);
	fbURL = "http://www.smsmac.com/cgi-bin/fb/sms" + fbURL;

	fbURL = fbURL.replace(/\&destination=/, "&to=");
	
	alert('calling fallback');
	
	// log query to console
	var hidePIN = fbURL;
	hidePIN = hidePIN.replace(/pin=\d\d\d\d/, "pin=xxxx");
	alert(hidePIN);
		
	// start animation
	if (drawInterval == null) {
		xpos = 0;
		step = 0;
		drawInterval = setInterval("walk();", 200);
	}
	
    if (window.XMLHttpRequest) {
        req = new XMLHttpRequest();
        req.onreadystatechange = processReqChange;
        req.open("GET", fbURL, true);
        req.send(null);
	} else {
		alert(fbURL);
	}
}

var eudora = new Image(19, 13);
eudora.src = 'images/letterb.png';

function walk()
{
	var canvas = document.getElementById("canvas");
	var context = canvas.getContext("2d");
	
	context.clearRect (0, 0, 125, 40);

	context.save();
	context.drawImage(eudora, xpos, 0, 19, 13);// x, y, width, height
	xpos += 20;
	
	if (xpos > 105)
		xpos = 0;
		
	context.restore();
}

function clearwalk()
{
	var canvas = document.getElementById("canvas");
	var context = canvas.getContext("2d");
	
	context.clearRect (0, 0, 125, 40);
}

function doChars(elem) 
{
	var txt = elem.value;//elem.innerText;
	var n = txt.length;
	var value = txt.charCodeAt(n-1);
	
	// ignore dead keys
	if (value == 96 || value == 94 || value == 168 || value == 176 || value == 180 || value == 710 || value == 732) {
		txt = txt.substring(0, n-1);
	}
	
	setMetrics(txt);
}

function setMetrics(txt)
{
	var n = 0;
	var nSMS = 0;
	var unicode = false;
	
	// determine SMS format
	if (window.widget) {
		if (ScriptObject.isUnicode(txt)) {
			unicode = true;
		}
	}
	
	// label Unicode
	if (unicode)
		document.getElementById("unicode").innerText = "Unicode";
	else
		document.getElementById("unicode").innerText = "";

	if (unicode)
		n = txt.length;
	else
		n = gsmLength(txt);

	// show number of characters	
	n = n + signatureLen;
	setTotal(n);
	
	// show number of SMS, i.e. [2] in case of Unicode SMS
	//if (unicode && n > 70) {
		//var elem = document.getElementById("total");
		//elem.innerText = elem.innerText + " [2 SMS]";
	//}
	
	nSMS = calculateNumberOfSMS(unicode, n);
	if (nSMS > 1) {
		var elem = document.getElementById("total");
		elem.innerText = elem.innerText + " [" + nSMS + " SMS]";
	}
}

function setTotal(n)
{
	document.getElementById("total").innerText = "#: " + n;
}

function getCallerID() {
	var callerID = "";
	
	var index = getReplyValue();
	switch(index) {
		case 0:
			callerID = document.getElementById("caller").value;
			break;
			
		case 1:
			callerID = document.getElementById("replyemailaddress").value;
			break;

		case 2:
			usealphanumericID = document.getElementById("usealphanumericID").checked;
			if (usealphanumericID) {
				callerID = document.getElementById("alphanumericID").value;
				if (callerID != "") {
				
					// accept only alphanumeric format
					callerID = callerID.replace(/[^\w.]/g, "");
					
					// feedback
					document.getElementById("alphanumericID").value = callerID;
					
					// cut it
					if (callerID.length > 11)
						callerID = callerID.substring(0, 11);
				}
			}
			break;
	}

	if (callerID.length > 0)
		return callerID;
		
	return null;
}

function getSignatureLen(txt) {
	var len = 0;
	var unicode = false;
	
	// determine SMS format
	if (window.widget) {
		if (ScriptObject.isUnicode(txt)) {
			unicode = true;
		}
	}
	
	if (unicode)
		len = txt.length;
	else
		len = gsmLength(txt);
	
	return len;
}

function getSignature() {

	var signaturetxt = document.getElementById("signaturetxt").value;
	var addsignature = document.getElementById("addsignature").checked;
		
	if (addsignature) {
		if (signaturetxt != null && signaturetxt.length > 0) {
			// insert a new line
			signaturetxt = String.fromCharCode(10) + signaturetxt;
			return signaturetxt;
		}
	} 
		
	return null;
}

function getDelivery() {
	return document.getElementById("delivery").checked;
}

function getCopySMS() {
	return document.getElementById("copysms").checked;
}

function gsmLength(txt)
{
	var sms = txt;
	var nEuros = 0;
    var len = sms.length;
        
	// there is a bug in replace regarding Euro...

    // how many Euro characters are there?
	for(var i=0;i<len;i++) {
		value = sms.charCodeAt(i);
		if (value == 8364)
			nEuros += 1;
	}
	
	// how many characters from the extension table?
	sms = sms.replace(/[\x5b\x5c\x5d\x5e\x7b\x7c\x7d\x7e]/g, "22");
	len = sms.length + nEuros;
	
	//alert("GSM Length is: " + len);
	
	return len;
}

function setHeadTooltip(name, mobile)
{
	var toolTip = getLocalizedString('Mobile Number');
	if (toolTip) {
		toolTip = toolTip.replace(/%s/i, name);
		toolTip = toolTip.replace(/%d/i, mobile);
		
		setHeaderTooltip(toolTip);
	}
}

function setHeaderTooltip(title)
{
	var head = document.getElementById("head");
	head.title = title;
}

function updateMobileNumber() {
	var mobile = "";
	var name = getLocalizedString('Unknown');
	
	var select = document.getElementById("popup");
	var defaultRecipientIndex = select.selectedIndex;
	
	if (defaultRecipientIndex == 0) {
		mobile = document.getElementById("to").value;
	} else {
		var dataValue = select.options[defaultRecipientIndex].value;
		var combo = dataValue.split('\r');
		if (combo.length > 0)
			mobile = combo[0];
		name = select.options[defaultRecipientIndex].text;
	}

	// make it international
	if (!isEmail(mobile))
		mobile = internationalNumber(mobile);	
			
	document.getElementById("to").value = mobile;
	
	setHeadTooltip(name, mobile);	
}

function internationalNumber(number) {
	if (number == null || number.length == 0)
		return number;
	
	// strip all formatting
	number = number.replace(/[^0-9+]/g, "");

	// we're done	
	if (number.charAt(0) == '+')
		return number;
		
	if (number.length < 2)
		return number;
		
	// we're done - support 00
	if (number.charAt(0) == '0' && number.charAt(1) == '0')
		return number;

	// we're done - support 011
	if (number.charAt(0) == '0' && number.charAt(1) == '1' && number.charAt(2) == '1')
		return number;

	// strip zero preference
	var stripzero = document.getElementById("stripzero").checked;
	if (stripzero) {
		// strip zero
		var ch = number.charAt(0);
		if (ch == '0') {
			number = number.substring(1);
		}
	}
	
	// add country code preference
	var addcountrycode = document.getElementById("addcountrycode").checked;

	// we're done
	if (!addcountrycode) return number;
		
	// add country code
	var countrycode = document.getElementById("countrycode").value;
	if (countrycode != null && countrycode.charAt(0) == '+')
		number = countrycode + number;
	
	return number;
}

function countrychanged()
{
	updateMobileNumber();
}

function doQueryBalance()
{
    var url = "http://backend.smsmac.com/balance.php?prod=WGT";
    url = url + productComputerVersion;
    
	// read account details
	var pin = document.getElementById("pin").value;;
	var email = document.getElementById("mail").value;

	// build query
	url = url + "&email=" + email + "&pin=" + pin;
  	
	// start animation
	if (checkInterval == null) {
		checkIndex = 0;
		checkInterval = setInterval("checkingBalance();", 100);
	}

    if (window.XMLHttpRequest) {
        req = new XMLHttpRequest();
        req.onreadystatechange = processQueryBalance;
        req.open("GET", url, true);
        req.send(null);
	} else {
		alert(url);
	}
}

function processQueryBalance() {
	var elem = document.getElementById('label36');
	
    // only if req shows "loaded"
    if (req.readyState == 4) {

		// stop animation
		if (checkInterval != null) {
			clearInterval(checkInterval);
			checkInterval = null;
		}

		// only if "OK"
        if (req.status == 200) {
            handleBalanceResponse(req.responseXML);
         } else {
         	alert("req.status != 200");
            elem.innerText = getLocalizedString('kErrNoInternet');
         }
    }
}

function handleBalanceResponse(xml)
{
    var balance = "?";
    var keyName = "";
    var dataValue = "";
    var success = false;
    
    var elem = document.getElementById('label36');
    
    var keys = xml.getElementsByTagName("key");
	if (keys.length <= 0) {
		alert("No valid response from balance query");
		elem.innerText = getLocalizedString('QueryNull');
		return;
	}
	
	// find all keys	
	for (i=0;i<keys.length;i++) {
		keyName = keys[i].firstChild.nodeValue;
		dataValue = keys[i].nextSibling.nextSibling.firstChild.data;
		
		switch(keyName) {
			case "Balance":
				success = true;
				balance = dataValue;
				break;
				
			case 'Error':
				error = dataValue;
				break;
				
			default:
				break;
		}
	}
	
	if (success) {
		elem.innerText = getLocalizedString('SMS Balance') + balance;
	} else {
		elem.innerText = getLocalizedString('kError') + error;
	}
}

function checkingBalance()
{
	var elem = document.getElementById('label36');
	var s = getLocalizedString('Checking');
	
	switch(checkIndex) {
		 case 0:
		 	elem.innerText = s + ".";
		 	break;
		 case 1:
		 	elem.innerText = s + "..";
		 	break;
		 case 2:
		 	elem.innerText = s + "...";
		 	break;
		 case 3:
		 	elem.innerText = s;
		 	break;
	}
	
	checkIndex += 1;
	checkIndex = checkIndex % 4;
}

function checking()
{
	var elem = document.getElementById('label21');
	var s = getLocalizedString('Checking');
	
	switch(checkIndex) {
		 case 0:
		 	elem.innerText = s + ".";
		 	break;
		 case 1:
		 	elem.innerText = s + "..";
		 	break;
		 case 2:
		 	elem.innerText = s + "...";
		 	break;
		 case 3:
		 	elem.innerText = s;
		 	break;
	}
	
	checkIndex += 1;
	checkIndex = checkIndex % 4;
}

function doCheckForUpdates()
{
    var url = "http://www.smsmac.com/cgi-bin/version.pl?prod=WGT";
    url = url + productComputerVersion;
    
	changeObjectVisibility("label21","visible");
	
	// start animation
	if (checkInterval == null) {
		checkIndex = 0;
		checkInterval = setInterval("checking();", 100);
	}

    if (window.XMLHttpRequest) {
        req = new XMLHttpRequest();
        req.onreadystatechange = processCheckUpdate;
        req.open("GET", url, true);
        req.send(null);
	} else {
		alert(url);
	}
}

function processCheckUpdate() {
	var elem = document.getElementById('label21');
	
    // only if req shows "loaded"
    if (req.readyState == 4) {

		// stop animation
		if (checkInterval != null) {
			clearInterval(checkInterval);
			checkInterval = null;
		}

		// only if "OK"
        if (req.status == 200) {
            handleUpdate(req.responseText);
         } else {
         	alert("req.status != 200");
            elem.innerText = getLocalizedString('kErrNoInternet');
         }
    }
}

function handleUpdate(responseText) {
	var elem = document.getElementById('label21');

	if (responseText == "uptodate") {
		elem.innerText = getLocalizedString('Up to Date');
	} else {
		changeObjectVisibility("download","visible");
		elem.innerText = getLocalizedString('Please Update');
		
		var responses = responseText.split(',');
		if (responses.length > 0) {
			version = responses[0];
			downloadURL = responses[1];
		}
	}
}

function doDownloadUpdate()
{	
	if (downloadURL.length > 0) {
		widget.openURL(downloadURL);
		downloadURL = "";
	}
	
	doHideUpdate(true);
}

function doHideUpdate(hide)
{	
	if (hide) {
		var elem = document.getElementById('label21');
		elem.innerText = getLocalizedString('Checking');

		changeObjectVisibility("download","hidden");
		changeObjectVisibility("label21","hidden");
	} else {
		changeObjectVisibility("download","visible");
		changeObjectVisibility("label21","visible");
	}
}

function showUpdate() 
{
	if (downloadURL != "")
		doHideUpdate(false);
	else
		doHideUpdate(true);
}
/*
function doAddEMobile() 
{	
	// handle case index = 0 separately
	
	// get emobile address
	var emobile = document.getElementById("emobi").value;
	if (emobile == "") return;
	
	// get contact list
	var popup2 = document.getElementById("popup2");
	
	// get select contact index
	var index = popup2.selectedIndex;
	
	// get contact name and value
	var name = popup2.options[index].text;
	var dataValue = popup2.options[index].value;
	
	// get unique id
	var uniqueid = "";
	var combo = dataValue.split('\r');
	if (combo == null || combo.length < 2) {
		alert('no unique ID found');
		return;
	} else {
		uniqueid = combo[1];
	}
	
	// construct data
	var newDataValue = emobile + '\r' + uniqueid;

	// add emobile address to card
	if (window.widget) {
		var error = ScriptObject.addemobile(newDataValue);
		if (error == 0) {
			alert('success add emobile');
		} else {
			alert('emobile could not be added');
		}
		
		// add new emobile entry to recipients popup
		if (error == 0) {
			var popup = document.getElementById("popup");

			// create new option element for emobile entry
			var elOptNew = document.createElement('option');
   			elOptNew.text = name + " (eMobile)";
    		elOptNew.value = newDataValue;
    		
    		var afterIndex = getRecipientIndex(dataValue);
    		if (afterIndex > 0) {
    			var elOptOld = popup.options[afterIndex+1];
    			popup.add(elOptNew, elOptOld);
    		}
		}
		
	}
}
*/
function getRecipientIndex(dataValue)
{	
	var popup = document.getElementById("popup");
	
	for(var i = 0;i<popup.options.length;i++) {
		if (popup.options[i].value == dataValue) {
			return i;
			break;
		}
	}
	
	return 0;
}

function doReloadContacts()
{
	adload();
}

function preSelectGroup(uid)
{
	var groups = document.getElementById('group');
	alert('preSelectGroup');
	for(var i = 0;i<groups.options.length;i++) {
		if (groups.options[i].value == uid) {
			groups.selectedIndex= i;
			break;
		}
	}
}

function pescape(s) {
	s = escape(s);
	return s.replace(/\+/g, '%2B');
}

function getPhoneNumbersList() {
	var phonenumber = "";
	
	// get list of mobile numbers
	if (window.widget) {
		var uid = getSelectedGroup();
				
		var list = ScriptObject.getgroupcontents(uid);
		
		if (list.length > 0) {
			for (var i = 0;i<list.length;i++) {
				
				mobileNo = list[i];				
				
				// skip these
				if (isEmail(mobileNo))
					continue;
				
				// make it international
				mobileNo = internationalNumber(mobileNo);
				alert(mobileNo);
				
				// check format of international mobile number
				if (mobileNo.charAt(0) == '+') {
					;						
				} else if (mobileNo.charAt(0) == '0' && mobileNo.charAt(1) == '0') {
					;
				} else if (mobileNo.charAt(0) == '0' && mobileNo.charAt(1) == '1' && mobileNo.charAt(2) == '1') {
					;
				} else {
					alert("mobile number not in international format.");
					// setStatusText(getLocalizedString('NoPlus'));
					return -1;
				}

				// concatenate them
				if (phonenumber.length == 0)
					phonenumber = mobileNo;// first entry of the list
				else
					phonenumber = phonenumber + "," + mobileNo;
			}
		}
	}
	
	return phonenumber;
}

function calculateNumberOfSMS(unicode, nChars) {
    var nSMS = 0;
    
    var len = lengthOfOneSMS(unicode)
    
    if (nChars <= len)
        nSMS = 1;
    else {
        // 7 octets = 7 * 8 = 56 bits, 56 bits / 7 bits = 8 characters in the GSM 7bit character set
        if (unicode)
            len = 70 - 7;
        else
            len = 160 - 7; // with testing it seems 153 can be contained
            
        nSMS = Math.floor(nChars / len );
        
        if ((nChars % len) != 0)
            nSMS += 1;
    }
        
    return nSMS;
}

function lengthOfOneSMS(unicode) {
    var len = 0;
    
    if (unicode)
        len = 70;
    else
        len = 160;
        
    return len;
}

function addCampaign(url, campaignName, addAccount) {
	var productCode = "WGT" + productComputerVersion;
	
	url = url + "&utm_source=dashboard&utm_medium=software&utm_content=" + productCode +"&utm_campaign=" + campaignName;
				
	if (addAccount) {
		var email = document.getElementById("mail").value;
		if (email != null && email.length != 0) {
			email = escape(email);
			url = url + "&account=" + email;
		}
	}
	
	return url;
}

function doRenewOpenURL() {
	if (window.widget) {
		var url = getLocalizedString('Renew SMS Mac');
		url = addCampaign(url, 'renew', true);
		widget.openURL(url);
	}
}

function doBuySMSOpenURL() {
	if (window.widget) {
		// Google Analytics Campaign - to do aanpassen localized string: 'BuyMore'
		var url = getLocalizedString('Buy SMS');
		url = addCampaign(url, 'buysms', true);
		widget.openURL(url);
	}
}

function doPurchaseOpenURL() {
	if (window.widget) {
		var url = addCampaign(purchaseURL, 'trialsms', true);
		widget.openURL(url);
	}
}

function doSoftwareUpdateURL() {
	if (window.widget) {	
		widget.openURL(productURL); 
	}
}

function findInArray(codes, value) {
	for (var i = 0; i<codes.length;i++) {
		if (codes[i] == value) {
			return true;
		}
	}
	
	return false;
}
